#
# Recupere les infos necessaires pour la connection a la DB
#

sub get_info_from_bm_ini {
    open(F, $bm_ini_file) || die "Error while opening : $!";
    while(<F>) {
        chomp() ;

        if($_ =~ m%db = (.*)%) {
            $values[0] = $1 ;    
        };   

        if($_ =~ m%host = (.*)%) {
            $values[1] = $1 ;    
        };

        if($_ =~ m%user = (.*)%) {
            $values[2] = $1 ;    
        };

        if($_ =~ m%password = \"(.*)\"%) {
            $values[3] = $1 ;    
        };

        
    };
    
    close(F) ;
    return @values ;


};


#
# Generation des fichiers xml avec 2 arguments 
# Type void()
#
# &write_this_to_xml($thisFile,$thisHashRef)
#
# 	$thisFile :  nom du fichier xml, path inclus 
#       $thisHashRef : pointeur vers le Hash de valeurs %new_aray

sub write_this_to_xml {

	my $thisFile = $_[0];	
	my $thisHashRef = $_[1];
	
	my %thisHash = %$thisHashRef ;

	open(FStat, "> $thisFile") || die "Error while opening : $!";
	print FStat "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
	print FStat " <statsbyuser>\n";

	for my $key (sort keys %thisHash) {
		if ($key =~ /^\d+$/ || $key =~ /^$/) { next;};
        	#if ($key =~ /^$/) { next;};
        	my $nombre = sum(@{$thisHash{$key}{'nb'}});
        	my $volume = sum(@{$thisHash{$key}{'vol'}});

        	print FStat "  <user>\n";
        	print FStat "   <name>$key</name>\n";
        	print FStat "   <mailSent>$nombre</mailSent>\n";
        	print FStat "   <mailSentTotalSize>$volume</mailSentTotalSize>\n";
        	print FStat "  </user>\n";
	
		delete $thisHashRef->{$key} ;
	};
	
	print FStat " </statsbyuser>\n";
	close FStat || die "Error while closing : $!";

	&do_resume_this_file($thisFile);
	
};



#
# Lecture des fichiers dans le rep. de stockages des .dat
# retourne un tableau de noms de fichiers
# 
# &opend_dir($rep,$format,$type)
#
#      $rep    : chemin vers le rep de stockage des fichiers dat
#      $format : prefixe des fichiers à trouver, par 2009_11_ pour les fichiers du mois de novembre
#      $type   : definition du mode de sélection  w= semaine, m=mensuel, y=annuel      
#




sub opend_dir {
    my $rep = $_[0];
    my $format = $_[1];
    my $type = $_[2];
    my @liste = ();
    
    opendir(dir,$rep);
    my @entrees = readdir(dir);
    closedir(dir);  
    foreach my $file (@entrees) {
        if(-f $rep."/".$file) {
			if($type eq "m")  {
                if( $file =~ m%$format(\d){1,2}_(\d){2}\.xml$%) { 
                    push @liste,$file;                          
                };
            };
             
            if ($type eq "w") {
                # Y_m_w_
                my @subpart = split(/_/,$format) ;
                my $thisyear = $subpart[0];
                my $thisweek = $subpart[2];                            
    
                if ($file =~ m%$thisyear\_(\d){2}_$thisweek\_.*\.xml%) {       
                    push @liste,$file;                          
                };
           	};

           	if($type eq "y") {
                if( $file =~ m%$format(\d){2}\.xml%) {     
                    push @liste,$file;                          
                };
          	};
        };
    };
    return @liste ;
};


#
# Controle existence du rep "$path_data_file.$sub"
# 

sub control_rep {
    my $rep = $_[0];
    if(opendir("dir","$rep")) {
       closedir("dir");  
    } else {
       mkpath("$rep");
    };
}




#
# retourne une date au format aaaa_mm_w_dd
# variable fournie : une date au format yyyy-mm-dd
# 

sub date_du_parse {
    my $date = undef ;
    my $x = $_[0];
    
    my @sub_part  = split(/-/,$x);
    my $an       = $sub_part[0];
    my $mois     = $sub_part[1];
    my $jour_mois = $sub_part[2];    
       
    my $semaine = Week_Number($an,$mois,$jour_mois);
    if( $semaine == 0) {
        $semaine = Week_Number($an-1,12,31);
    };
    $date = $an."_".$mois."_".$semaine."_".$jour_mois;
    $date =~ s/\s+//g;
    return $date;
};



#
# Parse un fichier xml fourni en variable 
# alimente un tableau assoc global  
# variables fournies :
# $0 : le nom du fichier (path inclus)
# $1 : le pointeur du Hash a alimenter %new_array
#

sub my_xml_parser {
    
    my $filename = $_[0];
    my $thisHashRef = $_[1];
	

    my $xml_user = "";
    my $xml_user_nb  = "";
    my $xml_user_vol = "";

    if( -e $filename ) { 

    	my $xml_content  = XMLin($filename,
       		ForceArray => 1,
          	KeyAttr    => {},
         	);

    	foreach my $value (@{$xml_content->{user}}) {
        	$xml_user    = $value->{name}->[0]; 
       	 	$xml_user_nb  = $value->{mailSent}->[0];            
        	$xml_user_vol = $value->{mailSentTotalSize}->[0];

          	push @{$thisHashRef->{$xml_user}{'nb'}},$xml_user_nb;
        	push @{$thisHashRef->{$xml_user}{'vol'}},$xml_user_vol;    
    	};
    };
};
#
# Parse un fichier xml fourni en variable
# alimente un tableau assoc global
# variables fournies :
# $0 : le nom du fichier (path inclus)
#

sub my_xml_parser_4_resume {
    my $filename = $_[0];
    my $xml_user = "";
    my $xml_user_nb  = "";
    my $xml_user_vol = "";

    %list_by_nb = () ;
    %list_by_vol= ();

    my $xml_content  = XMLin($filename,
       ForceArray => 1,
       KeyAttr    => {},
       );

    foreach my $value (@{$xml_content->{user}}) {
       $xml_user    = $value->{name}->[0];
       $xml_user_nb  = $value->{mailSent}->[0];
       $xml_user_vol = $value->{mailSentTotalSize}->[0];

       $list_by_nb{$xml_user}  = $xml_user_nb;
       $list_by_vol{$xml_user} = $xml_user_vol;
    };
};


#
# Genere un resume du fichier xml fourni en variable
# stocke dans /data/xml/resume/
# variables fournies :
# $0 : le nom du fichier (path inclus)
#

sub do_resume_this_file {
    my $this_file = $_[0] ;
    my $this_file_res = "$this_file" ;
    $this_file_res =~  s/(.*)(\/[0-9_]*\.xml)/\1\/resume\2/ ;

    #print "$this_file  -> $this_file_res \n" ;
    &my_xml_parser_4_resume($this_file);

    my @sorted_by_nb_tmp  = sort { $list_by_nb{$b} <=> $list_by_nb{$a} } keys %list_by_nb ;
    my @sorted_by_nb_res  = splice(@sorted_by_nb_tmp, 0 ,50) ;
    my @sorted_by_vol_tmp = sort { $list_by_vol{$b} <=> $list_by_vol{$a} } keys %list_by_vol ;
    my @sorted_by_vol_res = splice(@sorted_by_vol_tmp, 0, 50) ;

    #print Dumper(\\@sorted_by_nb_res); 

    open(FStatR, "> $this_file_res") || die "Error while opening : $!";
    #Ecriture de l'entete xml
    print FStatR"<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
    print FStatR " <statsbyuser>\n";

    print FStatR " <TopMailSent>\n";
    for my $key_nb (@sorted_by_nb_res) {
       if ($key_nb =~ /^\d+$/ || $key_nb =~ /^$/) { next;};
       #if ($key_nb =~ /^$/) { next;};

       print FStatR "  <user>\n";
       print FStatR "   <name>$key_nb</name>\n";
       print FStatR "   <mailSent>$list_by_nb{$key_nb}</mailSent>\n";
       print FStatR "   <mailSentTotalSize>$list_by_vol{$key_nb}</mailSentTotalSize>\n";
       print FStatR "  </user>\n";
    };
    print FStatR " </TopMailSent>\n";  
    
    print FStatR " <TopMailSentTotalSize>\n";
    for my $key_vol (@sorted_by_vol_res) {
       if ($key_vol =~ /^\d+$/ || $key_vol =~ /^$/) { next;};
       #if ($key_vol =~ /^$/) { next;};

       print FStatR "  <user>\n";
       print FStatR "   <name>$key_vol</name>\n";
       print FStatR "   <mailSent>$list_by_nb{$key_vol}</mailSent>\n";
       print FStatR "   <mailSentTotalSize>$list_by_vol{$key_vol}</mailSentTotalSize>\n";
       print FStatR "  </user>\n";
    };
    print FStatR " </TopMailSentTotalSize>\n";
    print FStatR " </statsbyuser>\n";
    close FStatR || die "Error while closing : $!";
};



# Alimente un fichier text pour chaque utilisateur 
# Arguments :
# $0 : reference vers HASH contenant les valeurs numeriques 
# $1 : le nom du fichier (path inclus)
# $2 : timestamp
sub alimUserFileStat {
    my $thisHashRef       = $_[0];
    my $innerThisUserFile = $_[1]; 
    my $innerTimestamp    = $_[2];

	my %values = %$thisHashRef ;
    my $ligne  = "$innerTimestamp,".$values{'nbf'}.",".$values{'volf'}.",".$values{'nbr'}.",".$values{'volr'}."," ;
	   $ligne .= $values{'nbAtt0'}.",".$values{'nbAtt1'}.",".$values{'nbAtt2'}.",".$values{'nbAtt3'}.",".$values{'nbAtt4'}.",".$values{'nbAtt5'}.",".$values{'nbAtt6'}.",";
	   $ligne .= $values{'volAtt100'}.",".$values{'volAtt200'}.",".$values{'volAtt500'}.",".$values{'volAtt1M'}.",".$values{'volAtt2M'}.",".$values{'volAtt3M'}.",".$values{'volAtt4M'}.",".$values{'volAtt5M'}.",".$values{'volAtt6M'}.",";
	   $ligne .= $values{'mimetype'} ;
	   $ligne .= "\n";
        
    open(addThisLine, ">> $innerThisUserFile") ||die "Error while closing : $!";
    print addThisLine "$ligne";
    close addThisLine ||die "Error while opening : $!";
        
};




# Retourne les infos pertinentes concernants les PJ (attachment)
# Arguments : 
# $0 : pointeur vers le tableau listant les pj
# $1 : volume global du message
#

sub mailFileAttSummInfo {
	
	

	my $thisHashRef = $_[0];
	my %internalArray   = %{$thisHashRef} ;
	my %resFile = () ;       
	my @internalArray   = keys %internalArray ; 
	my $thisVol     = $_[1]; 
 
	my $keyNb    = "0" ;
	my $keyVol   = "0" ;
	my $nbOfFile = "0"; 

 	foreach my $key (@internalArray) {
		if ($key ne "0" ) {
			$resFile{$key} = sum @{$internalArray{$key}} ;		 	
			$nbOfFile += sum @{$internalArray{$key}} ;	
		};
	};


	#print Dumper(\\ %resFile) ;

	# number of file  	
	if ($nbOfFile <= 5 ) {	
		$keyNb = $nbOfFile ;
	} else {
		$keyNb = "6" ;
	};

	# volume in octet 
	if( $thisVol < 100000 ) {
		$keyVol= "100" ;

	} elsif ( ($thisVol >= 100000) && ($thisVol < 200000) ) {
		$keyVol= "200" ;
	
	} elsif ( ($thisVol >= 200000) && ($thisVol < 500000) ) {
		$keyVol= "500" ;

	} elsif ( ($thisVol >= 500000) && ($thisVol < 1000000) ) {
		$keyVol= "1M" ;

	} elsif ( ($thisVol >= 1000000) && ($thisVol < 2000000) ) {
		$keyVol= "2M" ;

	} elsif ( ($thisVol >= 2000000) && ($thisVol < 3000000) ) {
		$keyVol= "3M" ;

	} elsif ( ($thisVol >= 3000000) && ($thisVol < 4000000) ) {
		$keyVol= "4M" ;

	} elsif ( ($thisVol >= 4000000) && ($thisVol < 5000000) ) {
		$keyVol= "5M" ;
	
	} else {
		$keyVol= "6M" ;

	};
	
	my @tab = ($keyNb,$keyVol,%resFile) ;

};
#
# Retourne le nombre d'elements et la somme de ceux-ci dans un tableau 
# &getEntryVolumeValues($thisHashRef)
#        $thisHashRef : pointeur vers le Hash de valeurs $compteur{_domain_}{_cle_horaire_}
#
sub getEntryVolumeValues() {

    # init VAR
    my @liste = () ;
    #my @thisHashRef = @{$_[0]} ;
    my %entry = @{$_[0]} ;

    my @entry = values (%entry) ;
    my $nbOfElements = @entry ;
    my $sumOfElements = sum(@entry) ;

    $liste[0] = $nbOfElements + 0 ;
    $liste[1] = $sumOfElements + 0 ;

    return @liste ;
} ;



# Alimente la table stat dans la base OBS
# Argument :
# date au format yyyy-mm-dd, ie : 2011-03-13
# domain (zzgestion-xxxx), ie : zzgestion-sdes75

sub alimGeneralStatFile {     
    my $this_date   = $_[0];
	  $this_date =~ s/\n// ;
    my $this_domain = $_[1];


    my $domainGeneralStatFile    = $this_general_dir."/domainGeneralStat.dat";
    my $domainDSNStatFile        = $this_general_dir."/domainDSNStat.dat";
    my $domainAttachemntStatFile = $this_general_dir."/domainAttachmentStat.dat";
    my $domainNbRecipByPost      = $this_general_dir."/domainNbRecipByPost.dat";

	
    # MIME Case 
    my $mimetype = "" ;

    my @tempArray = () ;
    foreach my $thisDomainFileMimetype (keys %{$compteur{$this_domain}{'mimetype'}} ) {
    	my $thisMimeSum = 0;
        $thisMimeSum = sum (@{$compteur{$this_domain}{'mimetype'}{$thisDomainFileMimetype}}) ;
        push @tempArray, $thisDomainFileMimetype.":".$thisMimeSum;
	};

    $mimetype = join (";",@tempArray) ;

    
    # Nb RECIP case
    my $rcptType = "" ;
    my @tempArray = () ;
    
    foreach my $nbRecip ( keys (%{$compteur{$this_domain}{'nbRcpt'}})) {
        my $thisnbRecipSum = 0 ;
        $thisnbRecipSum = sum (@{$compteur{$this_domain}{'nbRcpt'}{$nbRecip}}) ;
        push @tempArray, $nbRecip.":".$thisnbRecipSum ;
    };
    $rcptType = join (";",@tempArray) ;
        
            
    
    
    
    my ($nbT, $volT)     =  &getEntryVolumeValues($compteur{$this_domain}{nbT}) ;
    my ($nbT00, $volT00) =  &getEntryVolumeValues($compteur{$this_domain}{nbT00}) ;
    my ($nbT01, $volT01) =  &getEntryVolumeValues($compteur{$this_domain}{nbT01}) ;
    my ($nbT02, $volT02) =  &getEntryVolumeValues($compteur{$this_domain}{nbT02}) ;
    my ($nbT03, $volT03) =  &getEntryVolumeValues($compteur{$this_domain}{nbT03}) ;
    my ($nbT04, $volT04) =  &getEntryVolumeValues($compteur{$this_domain}{nbT04}) ;
    my ($nbT05, $volT05) =  &getEntryVolumeValues($compteur{$this_domain}{nbT05}) ;
    my ($nbT06, $volT06) =  &getEntryVolumeValues($compteur{$this_domain}{nbT06}) ;
    my ($nbT07, $volT07) =  &getEntryVolumeValues($compteur{$this_domain}{nbT07}) ;
    my ($nbT08, $volT08) =  &getEntryVolumeValues($compteur{$this_domain}{nbT08}) ;
    my ($nbT09, $volT09) =  &getEntryVolumeValues($compteur{$this_domain}{nbT09}) ;
    my ($nbT10, $volT10) =  &getEntryVolumeValues($compteur{$this_domain}{nbT10}) ;
    my ($nbT11, $volT11) =  &getEntryVolumeValues($compteur{$this_domain}{nbT11}) ;
    my ($nbT12, $volT12) =  &getEntryVolumeValues($compteur{$this_domain}{nbT12}) ;
    my ($nbT13, $volT13) =  &getEntryVolumeValues($compteur{$this_domain}{nbT13}) ;
    my ($nbT14, $volT14) =  &getEntryVolumeValues($compteur{$this_domain}{nbT14}) ;
    my ($nbT15, $volT15) =  &getEntryVolumeValues($compteur{$this_domain}{nbT15}) ;
    my ($nbT16, $volT16) =  &getEntryVolumeValues($compteur{$this_domain}{nbT16}) ;
    my ($nbT17, $volT17) =  &getEntryVolumeValues($compteur{$this_domain}{nbT17}) ;
    my ($nbT18, $volT18) =  &getEntryVolumeValues($compteur{$this_domain}{nbT18}) ;
    my ($nbT19, $volT19) =  &getEntryVolumeValues($compteur{$this_domain}{nbT19}) ;
    my ($nbT20, $volT20) =  &getEntryVolumeValues($compteur{$this_domain}{nbT20}) ;
    my ($nbT21, $volT21) =  &getEntryVolumeValues($compteur{$this_domain}{nbT21}) ;
    my ($nbT22, $volT22) =  &getEntryVolumeValues($compteur{$this_domain}{nbT22}) ;
    my ($nbT23, $volT23) =  &getEntryVolumeValues($compteur{$this_domain}{nbT23}) ;





    ## CASE of general stat
    #
    my $domainGeneralStatLine  = "$this_date,";
       $domainGeneralStatLine .= "$this_domain,";
       
       
       # Posts filled
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{nbt}} ).",".sum( @{$compteur{$this_domain}{nbt00}} ).",".sum( @{$compteur{$this_domain}{nbt01}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{nbt02}} ).",".sum( @{$compteur{$this_domain}{nbt03}} ).",".sum( @{$compteur{$this_domain}{nbt04}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{nbt05}} ).",".sum( @{$compteur{$this_domain}{nbt06}} ).",".sum( @{$compteur{$this_domain}{nbt07}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{nbt08}} ).",".sum( @{$compteur{$this_domain}{nbt09}} ).",".sum( @{$compteur{$this_domain}{nbt10}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{nbt11}} ).",".sum( @{$compteur{$this_domain}{nbt12}} ).",".sum( @{$compteur{$this_domain}{nbt13}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{nbt14}} ).",".sum( @{$compteur{$this_domain}{nbt15}} ).",".sum( @{$compteur{$this_domain}{nbt16}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{nbt17}} ).",".sum( @{$compteur{$this_domain}{nbt18}} ).",".sum( @{$compteur{$this_domain}{nbt19}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{nbt20}} ).",".sum( @{$compteur{$this_domain}{nbt21}} ).",".sum( @{$compteur{$this_domain}{nbt22}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{nbt23}} ).",";
       
       # Posts sent 
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{nbf}} ).",".sum( @{$compteur{$this_domain}{nbf00}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{nbf01}} ).",".sum( @{$compteur{$this_domain}{nbf02}} ).",".sum( @{$compteur{$this_domain}{nbf03}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{nbf04}} ).",".sum( @{$compteur{$this_domain}{nbf05}} ).",".sum( @{$compteur{$this_domain}{nbf06}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{nbf07}} ).",".sum( @{$compteur{$this_domain}{nbf08}} ).",".sum( @{$compteur{$this_domain}{nbf09}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{nbf10}} ).",".sum( @{$compteur{$this_domain}{nbf11}} ).",".sum( @{$compteur{$this_domain}{nbf12}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{nbf13}} ).",".sum( @{$compteur{$this_domain}{nbf14}} ).",".sum( @{$compteur{$this_domain}{nbf15}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{nbf16}} ).",".sum( @{$compteur{$this_domain}{nbf17}} ).",".sum( @{$compteur{$this_domain}{nbf18}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{nbf19}} ).",".sum( @{$compteur{$this_domain}{nbf20}} ).",".sum( @{$compteur{$this_domain}{nbf21}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{nbf22}} ).",".sum( @{$compteur{$this_domain}{nbf23}} ).",";
       
       # Volume sent 
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{volf}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{volf00}} ).",".sum( @{$compteur{$this_domain}{volf01}} ).",".sum( @{$compteur{$this_domain}{volf02}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{volf03}} ).",".sum( @{$compteur{$this_domain}{volf04}} ).",".sum( @{$compteur{$this_domain}{volf05}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{volf06}} ).",".sum( @{$compteur{$this_domain}{volf07}} ).",".sum( @{$compteur{$this_domain}{volf08}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{volf09}} ).",".sum( @{$compteur{$this_domain}{volf10}} ).",".sum( @{$compteur{$this_domain}{volf11}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{volf12}} ).",".sum( @{$compteur{$this_domain}{volf13}} ).",".sum( @{$compteur{$this_domain}{volf14}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{volf15}} ).",".sum( @{$compteur{$this_domain}{volf16}} ).",".sum( @{$compteur{$this_domain}{volf17}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{volf18}} ).",".sum( @{$compteur{$this_domain}{volf19}} ).",".sum( @{$compteur{$this_domain}{volf20}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{volf21}} ).",".sum( @{$compteur{$this_domain}{volf22}} ).",".sum( @{$compteur{$this_domain}{volf23}} ).",";
       
       # Volume filled
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{volt}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{volt00}} ).",".sum( @{$compteur{$this_domain}{volt01}} ).",".sum( @{$compteur{$this_domain}{volt02}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{volt03}} ).",".sum( @{$compteur{$this_domain}{volt04}} ).",".sum( @{$compteur{$this_domain}{volt05}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{volt06}} ).",".sum( @{$compteur{$this_domain}{volt07}} ).",".sum( @{$compteur{$this_domain}{volt08}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{volt09}} ).",".sum( @{$compteur{$this_domain}{volt10}} ).",".sum( @{$compteur{$this_domain}{volt11}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{volt12}} ).",".sum( @{$compteur{$this_domain}{volt13}} ).",".sum( @{$compteur{$this_domain}{volt14}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{volt15}} ).",".sum( @{$compteur{$this_domain}{volt16}} ).",".sum( @{$compteur{$this_domain}{volt17}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{volt18}} ).",".sum( @{$compteur{$this_domain}{volt19}} ).",".sum( @{$compteur{$this_domain}{volt20}} ).",";
       $domainGeneralStatLine .= sum( @{$compteur{$this_domain}{volt21}} ).",".sum( @{$compteur{$this_domain}{volt22}} ).",".sum( @{$compteur{$this_domain}{volt23}} )."," ;
       
       # Posts received
       $domainGeneralStatLine .= "$nbT,$nbT00,$nbT01,$nbT02,$nbT03,$nbT04,$nbT05,$nbT06,$nbT07,$nbT08,$nbT09,$nbT10,$nbT11,$nbT12,$nbT13,$nbT14,$nbT15,$nbT16,$nbT17,$nbT18,$nbT19,$nbT20,$nbT21,$nbT22,$nbT23,";
       
       # Volume received
       $domainGeneralStatLine .= "$volT,$volT00,$volT01,$volT02,$volT03,$volT04,$volT05,$volT06,$volT07,$volT08,$volT09,$volT10,$volT11,$volT12,$volT13,$volT14,$volT15,$volT16,$volT17,$volT18,$volT19,$volT20,$volT21,$volT22,$volT23"; 
       
       $domainGeneralStatLine .= "\n";

    open(addThisLine, ">> $domainGeneralStatFile") ||die "Error while closing : $!";
    print addThisLine "$domainGeneralStatLine";
    close addThisLine ||die "Error while opening : $!";


    
    ## CASE of deferred/bounced POST
    #
    my $domainDSNStatLine  = "$this_date,$this_domain,".sum( @{$compteur{$this_domain}{deferred}} ).",".sum( @{$compteur{$this_domain}{deferred00}} ).",".sum( @{$compteur{$this_domain}{deferred01}} ).",";
       $domainDSNStatLine .= sum( @{$compteur{$this_domain}{deferred02}} ).",".sum( @{$compteur{$this_domain}{deferred03}} ).",".sum( @{$compteur{$this_domain}{deferred04}} ).",";
       $domainDSNStatLine .= sum( @{$compteur{$this_domain}{deferred05}} ).",".sum( @{$compteur{$this_domain}{deferred06}} ).",".sum( @{$compteur{$this_domain}{deferred07}} ).",";
       $domainDSNStatLine .= sum( @{$compteur{$this_domain}{deferred08}} ).",".sum( @{$compteur{$this_domain}{deferred09}} ).",".sum( @{$compteur{$this_domain}{deferred10}} ).",";
       $domainDSNStatLine .= sum( @{$compteur{$this_domain}{deferred11}} ).",".sum( @{$compteur{$this_domain}{deferred12}} ).",".sum( @{$compteur{$this_domain}{deferred13}} ).",";
       $domainDSNStatLine .= sum( @{$compteur{$this_domain}{deferred14}} ).",".sum( @{$compteur{$this_domain}{deferred15}} ).",".sum( @{$compteur{$this_domain}{deferred16}} ).",";
       $domainDSNStatLine .= sum( @{$compteur{$this_domain}{deferred17}} ).",".sum( @{$compteur{$this_domain}{deferred18}} ).",".sum( @{$compteur{$this_domain}{deferred19}} ).",";
       $domainDSNStatLine .= sum( @{$compteur{$this_domain}{deferred20}} ).",".sum( @{$compteur{$this_domain}{deferred21}} ).",".sum( @{$compteur{$this_domain}{deferred22}} ).",";
       $domainDSNStatLine .= sum( @{$compteur{$this_domain}{deferred23}} ).",".sum( @{$compteur{$this_domain}{bounced}} ).",".sum( @{$compteur{$this_domain}{bounced00}} ).",";
       $domainDSNStatLine .= sum( @{$compteur{$this_domain}{bounced01}} ).",".sum( @{$compteur{$this_domain}{bounced02}} ).",".sum( @{$compteur{$this_domain}{bounced03}} ).",";
       $domainDSNStatLine .= sum( @{$compteur{$this_domain}{bounced04}} ).",".sum( @{$compteur{$this_domain}{bounced05}} ).",".sum( @{$compteur{$this_domain}{bounced06}} ).",";
       $domainDSNStatLine .= sum( @{$compteur{$this_domain}{bounced07}} ).",".sum( @{$compteur{$this_domain}{bounced08}} ).",".sum( @{$compteur{$this_domain}{bounced09}} ).",";
       $domainDSNStatLine .= sum( @{$compteur{$this_domain}{bounced10}} ).",".sum( @{$compteur{$this_domain}{bounced11}} ).",".sum( @{$compteur{$this_domain}{bounced12}} ).",";
       $domainDSNStatLine .= sum( @{$compteur{$this_domain}{bounced13}} ).",".sum( @{$compteur{$this_domain}{bounced14}} ).",".sum( @{$compteur{$this_domain}{bounced15}} ).",";
       $domainDSNStatLine .= sum( @{$compteur{$this_domain}{bounced16}} ).",".sum( @{$compteur{$this_domain}{bounced17}} ).",".sum( @{$compteur{$this_domain}{bounced18}} ).",";
       $domainDSNStatLine .= sum( @{$compteur{$this_domain}{bounced19}} ).",".sum( @{$compteur{$this_domain}{bounced20}} ).",".sum( @{$compteur{$this_domain}{bounced21}} ).",";
       $domainDSNStatLine .= sum( @{$compteur{$this_domain}{bounced22}} ).",".sum( @{$compteur{$this_domain}{bounced23}} ) ;
       $domainDSNStatLine .= "\n";

    open(addThisLine, ">> $domainDSNStatFile") ||die "Error while closing : $!";
    print addThisLine "$domainDSNStatLine";
    close addThisLine ||die "Error while opening : $!";

    

    ## CASE of Attachment by POST
    #
       my $domainAttachemntStatLine  = "$this_date,$this_domain,".sum( @{$compteur{$this_domain}{'nbAtt'}{'0'}} ).",".sum( @{$compteur{$this_domain}{'nbAtt'}{'1'}} ).",";
       $domainAttachemntStatLine .= sum( @{$compteur{$this_domain}{'nbAtt'}{'2'}} ).",".sum( @{$compteur{$this_domain}{'nbAtt'}{'3'}} ).",".sum( @{$compteur{$this_domain}{'nbAtt'}{'4'}} ).",";
       $domainAttachemntStatLine .= sum( @{$compteur{$this_domain}{'nbAtt'}{'5'}} ).",".sum( @{$compteur{$this_domain}{'nbAtt'}{'6'}} ).",".sum( @{$compteur{$this_domain}{'volAtt'}{'100'}} ).",";
       $domainAttachemntStatLine .= sum( @{$compteur{$this_domain}{'volAtt'}{'200'}} ).",".sum( @{$compteur{$this_domain}{'volAtt'}{'500'}} ).",".sum( @{$compteur{$this_domain}{'volAtt'}{'1M'}} ).",";
       $domainAttachemntStatLine .= sum( @{$compteur{$this_domain}{'volAtt'}{'2M'}} ).",".sum( @{$compteur{$this_domain}{'volAtt'}{'3M'}} ).",".sum( @{$compteur{$this_domain}{'volAtt'}{'4M'}} ).",";
       $domainAttachemntStatLine .= sum( @{$compteur{$this_domain}{'volAtt'}{'5M'}} ).",".sum( @{$compteur{$this_domain}{'volAtt'}{'6M'}} ).",".$mimetype ;
       $domainAttachemntStatLine .= "\n";

    open(addThisLine, ">> $domainAttachemntStatFile") ||die "Error while closing : $!";
    print addThisLine "$domainAttachemntStatLine";
    close addThisLine ||die "Error while opening : $!";





    ## CASE of Nb RECIP by POST
    #
    my $domainNbRecipByPostLine = "$this_date,$this_domain,$rcptType\n" ;

    open(addThisLine, ">> $domainNbRecipByPost") ||die "Error while closing : $!";
    print addThisLine $domainNbRecipByPostLine ;
    close addThisLine ||die "Error while opening : $!";

};

# return the beginning of lines in mail.log to be parsed stored in an array
# ARG :
# $_0 : nb of minutes to parsed (the x lastest ones), i.e. 5 for the 5 lastest minutes
#

sub time_limit {
    my @dbt = ();
    my @res = ();
    my @date = () ;
    my $x = $_[0] - 1;
    my $Jour_Mois = "" ;

    for (my $i=$x; $i>=0; $i--) {
        my $dudul = time - ($i*60);
        my ($secondes, $minutes, $heures, $jour_mois, $mois,$an, $jour_semaine, $jour_calendaire, $heure_ete) = localtime($dudul);
        $an +=1900;
        $mois+=1;
        $jour_calendaire+=1;
        $mois = $mois < 10 ? $mois = "0".$mois : $mois;
        $Jour_Mois = $jour_mois < 10 ? $Jour_Mois = "0".$jour_mois : $jour_mois;
        $jour_mois = $jour_mois < 10 ? $jour_mois = " ".$jour_mois : $jour_mois;
        $heures = $heures < 10 ? $heures = "0".$heures : $heures;
        $minutes = $minutes < 10 ? $minutes = "0".$minutes : $minutes;
        my @noms_de_mois = ("","Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");

        push(@dbt,"$noms_de_mois[$mois] $jour_mois $heures:$minutes");
        push @date, "$an/$mois/$Jour_Mois" ;
    };

    #my $trash = shift(@dbt);
    $res[0] = $dbt[0];
    $res[1] = join "|",@dbt;
    $res[2] = $date[0];

    return @res ;
};


sub readLastCyrusConnexionFile() {

    my $thisFile    = $_[0] ;
    my $userHashKey = $_[1] ;
    my @userList = @{$userHashKey};

    my %contenu = () ;
    my $this_user = "" ;

    if(open(Fcyrus,"$thisFile")) {
        while(<Fcyrus>) {
            chomp() ;
            my @val = split(";",$_);
            my $user = shift(@val) ;

            # Suppression des veilles entrees
            if( grep(/$user/, @userList) ) {
                @{$contenu{$user}} = @val ;
            };
        };
    } else {
        open(Fcyrus,"> $thisFile");
        foreach $this_user (@userList ) {
            print Fcyrus "$this_user";
            push @{$contenu{$this_user}},"" ;
        };
    };

    close(Fcyrus);

    return %contenu ;
};


#
## Lecture du fichier lastUserAgentConnexion.dat et alimentation d'un HASH, et retour de ce dernier
#

sub readLastUserAgentConnexionFile() {

    my $thisFile    = $_[0] ;
    my $userHashKey = $_[1] ;
    my @userList = @{$userHashKey};


    my %contenu = () ;
    my $this_user = "" ;

    if(open(FuserAgent,"$thisFile")) {
        while(<FuserAgent>) {
            chomp() ;
            my @val = split(";",$_);
            my $user = $val[0] ;
            
            # Suppression des veilles entrees
            if( grep (/$user/, @userList) ) {
                $contenu{$user} = $val[1] ;
            };
        };
    } else {
        open(FuserAgent,"> $thisFile");
        foreach $this_user (@userList ) {
            print Fcyrus "$this_user";
            $contenu{$this_user} = "" ;
        };
    };

    close(Fcyrus);

    return %contenu ;
};

#
## Lecture du fichier lastUserAgentConnexion.dat et alimentation d'un HASH, et retour de ce dernier
#

sub readRealTimeFile() {

    my $thisFile    = $_[0] ;
    my %contenu = () ;

    if(open(FrealTimeFile,"$thisFile")) {
        while(<FrealTimeFile>) {
            chomp() ;
            my @val = split(";",$_);
            my $timestamp = $val[0] ;
            $contenu{$timestamp} = $val[1] ;
		};
	
		close(FrealTimeFile);
	};

    return %contenu ;
};


1;
