#!/usr/bin/perl

BEGIN {
    push @INC,"/usr/share/bm-stats/scripts/PERL/";
};


require "bmFunctions.pl";


#use strict;
use Data::Dumper qw(Dumper);
use XML::Simple qw(:strict);
use List::Util qw(sum);
use Date::Calc qw(Week_Number Mktime);
use Encode ;
use File::Path ;
use File::Copy ;

######################################
#
# Var settings
#
######################################


my $date = $ARGV[0]; # Date with format yyyy-mm-dd

if( $date !~ m%\d{4}-\d{2}-\d{2}% ) {
    $date = `date --date '1 days ago' +%F`;
};




my $path_to_data_dir = "/var/lib/bm-stats/" ;
our $this_general_dir = $path_to_data_dir."/general";
   &control_rep($this_general_dir);

my $path_to_log_file = "/var/log/";
my $log_file = $path_to_log_file."mail.log.0" ;
my $superkey = "";
my $this_address  = "" ;
my $this_gestionnaire = "" ;
my $this_vol = 0 ;
my $this_hour = "";
my $this_SenderDomain= "" ;
my $this_RecipDomain = "" ;
my $this_FileName = "";
my $this_minetype = "" ;
my $filetype = "" ;

my @prefixe  = ();
my @index = ('','00','01','02','03','04','05','06','07','08','09','10','11','12','13','14','15','16','17','18','19','20','21','22','23');
my @indexNbAtt = ('0','1','2','3','4','5','6') ;
my @indexVolAtt = ('100','200','500','1M','2M','3M','4M','5M','6M') ;
my @this_SenderDomainPart = ();
my @mimetype = () ;

my %local_address = ();
my %all_queueid = () ;
my %postfixId   = () ;
my %thisFileExtentionListSum = () ;
my %fileExtentionListSum = () ;

our %compteur        = ();
our %list_by_nb      = ();
our %list_by_vol     = ();
our %list_vol_by_msgID = ();
our %list_domain_by_postfixId = ();
our %senderDomainByGestionnaire = ();
our %localSender = () ;
our %recipDomainByGestionnaire = ();
our %fileList = () ;




#
###################################################################

######################################
#
# Local Function
#
######################################

#
# Have a look in "function.pl" file
#


#
####################################################################


#######################################
#
# Job starting HERE
#
#######################################


#
# Date settings
#
my $Jour_mois = "" ;
my $Jour_Mois = "" ;
my @noms_de_mois = ("","Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");
my @sub_part = split(/-/,$date);

my $an        = $sub_part[0];
my $mois      = $sub_part[1];
my $jour_mois = $sub_part[2] + 0 ;
my $timestamp = Mktime($an,$mois,$jour_mois,0,0,0);

#Day in format " 1"," 2"..."10"..
$Jour_mois = $jour_mois < 10 ? $Jour_mois = " ".$jour_mois : $jour_mois;
#Day in format "01","02"..."10"..
$Jour_Mois = $jour_mois < 10 ? $Jour_Mois = "0".$jour_mois : $jour_mois;




#
# Beginning of each line, filelog name to parse 
#
my $dbt = "$noms_de_mois[$mois] $Jour_mois ";


#print "$log_file $dbt \n";
####
##  Var explaination
#   
# nbf      : number of posts by from 
# nbAtT    : number of Attachement by post
# nbt      : number of posts filled, all dest. of a domain are count there
# nbT      : number of posts received, only the message for the domain even if more than 1 dest.
# nbRcpt   : number of dests/post 
# volt     : volume of posts filled
# volf     : volume of the entire message
# volAtt   : volume the entire message while x attachment
# bounced  : number of bounced messages
# deferred : number of deferred messages
##
####


#Init hourly counters
foreach my $index (@index) {
	my $this_nbf_index      = "nbf".$index;
	my $this_nbAtt_index    = "nbAtt".$index;
	my $this_nbt_index      = "nbt".$index;
    my $this_nbT_index      = "nbT".$index;
    my $this_volt_index     = "volt".$index;
    my $this_volf_index     = "volf".$index;
	my $this_volAtt_index   = "volAtt".$index;
	my $this_bounced_index  = "bounced".$index;
	my $this_deferred_index = "deferred".$index;


	# Setting "Externe" account counters
    push @{$compteur{'Externe'}{$this_nbf_index}},0;
	push @{$compteur{'Externe'}{$this_nbt_index}},0;
    push @{$compteur{'Externe'}{$this_volt_index}},0;
    push @{$compteur{'Externe'}{$this_volf_index}},0;
    push @{$compteur{'Externe'}{$this_bounced_index}},0;
	push @{$compteur{'Externe'}{$this_deferred_index}},0;

    @{$compteur{'Externe'}{$this_nbT_index}} = () ; # will be feed as "push @{$compteur{...}}, (x => y);"


	# Setting "GlobalServer" account counters
	push @{$compteur{'GlobalServer'}{$this_nbf_index}},0;
	push @{$compteur{'GlobalServer'}{$this_nbt_index}},0;
	push @{$compteur{'GlobalServer'}{$this_volt_index}},0;
    push @{$compteur{'GlobalServer'}{$this_volf_index}},0;
	push @{$compteur{'GlobalServer'}{$this_bounced_index}},0;
    push @{$compteur{'GlobalServer'}{$this_deferred_index}},0;

    push @{$compteur{'GlobalServer'}{$this_nbT_index}}, ; # will be feed as "push @{$compteur{...}}, (x => y);"

};

#Init Global Server counters for nb of attachment/mail
foreach my $indexNbAtt (@indexNbAtt) {
    push @{$compteur{'GlobalServer'}{'nbAtt'}{$indexNbAtt}},0 ;    
};

#Init Global Server counters for vol of entire mail if 1+ attachment
foreach my $indexVolAtt (@indexVolAtt) {
    push @{$compteur{'Externe'}{'volAtt'}{$indexVolAtt}},0 ;
};



#
# PHP exporting data from PostGreS through API
#

%local_address = split (/ /,`/usr/bin/php5 /usr/share/bm-stats/scripts/PHP/api/listAllMailbox.php`) ;

foreach $this_address (keys %local_address) {

    $this_gestionnaire = $local_address{$this_address};
    @prefixe = split(/\@/,$this_address);
    $superkey = $prefixe[0];


    if( $superkey ne "") {

        # Concerne la gestion des stats par domaine
        # Je sais : je le fais autant de fois qu'il y a de users ;-)
        $this_gestionnaire = $domain_name ;

        foreach my $index (@index) {
		my $this_nbf_index      = "nbf".$index;
		my $this_nbAtt_index    = "nbAtt".$index;
		my $this_nbt_index      = "nbt".$index;
        my $this_nbT_index      = "nbT".$index;
        my $this_volt_index     = "volt".$index;
		my $this_volf_index     = "volf".$index;
		my $this_volAtt_index   = "volAtt".$index;
		my $this_bounced_index  = "bounced".$index;
		my $this_deferred_index = "deferred".$index;

        # Setting account counters
		push @{$compteur{$this_gestionnaire}{$this_nbf_index}},0 ;
		push @{$compteur{$this_gestionnaire}{$this_nbt_index}},0 ;
		push @{$compteur{$this_gestionnaire}{$this_volt_index}},0 ;
        push @{$compteur{$this_gestionnaire}{$this_volf_index}},0 ;
		push @{$compteur{$this_gestionnaire}{$this_bounced_index}},0 ;
		push @{$compteur{$this_gestionnaire}{$this_deferred_index}},0 ;

        @{$compteur{$this_gestionnaire}{$this_nbT_index}} = () ; # will be feed as "push @{$compteur{...}}, (x => y);"

        };

        foreach my $indexNbAtt (@indexNbAtt) {
               push @{$compteur{$this_gestionnaire}{'nbAtt'}{$indexNbAtt}},0 ;
        };

        foreach my $indexVolAtt (@indexVolAtt) {
            push @{$compteur{$this_gestionnaire}{'volAtt'}{$indexVolAtt}},0 ;
        };


        # Gestion de l'adresse principale
        push @{$compteur{$this_gestionnaire}{$superkey}{'nbf'}},0 ;
        push @{$compteur{$this_gestionnaire}{$superkey}{'volf'}},0 ;
        push @{$compteur{$this_gestionnaire}{$superkey}{'nbr'}},0 ;
        push @{$compteur{$this_gestionnaire}{$superkey}{'volr'}},0 ;

        foreach my $indexNbAtt (@indexNbAtt) {
            push @{$compteur{$this_gestionnaire}{$superkey}{'nbAtt'}{$indexNbAtt}},0 ;        
        };

        foreach my $indexVolAtt (@indexVolAtt) {
            push @{$compteur{$this_gestionnaire}{$superkey}{'volAtt'}{$indexVolAtt}},0 ;
        };

    };
};




#print Dumper(\\%local_address) ;


#
# LogFile Parse
#


open(F, $log_file) || die "Error while opening : $!";
while(<F>) {
    if($_ =~ m%^$dbt%) {
		chomp();  
		my $this_line = $_;
        my $this_queueId = "" ;
		$this_line =~ s/\s+/ /g;
		my @element = split(/ /,$this_line);
		my @hour    = split(/:/,$element[2]);
		$this_hour = $hour[0];        
		
        #List of postfix_queueid while internal treatment (antivirus/antispam)
        #Aug 22 15:38:15 galadriel postfix/smtpd[29211]: 7E83C9E4318: client=.*
        #              1      2      3         4          5       6   
        if ( $_ =~ m%(.*)(:\d{2}\s)(.*)(postfix/smtpd)\[(\d+)\]: (.*): client=.*% ) {
            $all_queueid{$6} = 0;
        };

        #List of message_id
        #Aug 22 20:09:21 galadriel postfix/cleanup[11415]: 6C54B9E433D: message-id=<20090822200921.9q4fg64u0wg4swkw@mail.mclabosse.fr>
        #             1          2            3       4                 5
        if ( $_ =~ m%(.*)(postfix/cleanup)\[(\d+)\]: (.*): message-id=(.*)% ) {
            # want to keep only one "from" line per message.
            # the same message_id can be found twice
            my $this_msgID = "$5" ;

            my %ReversePostfixId = reverse %postfixId ;

            if( exists($ReversePostfixId{$this_msgID}) ) {
            } else {
                $postfixId{$4} = $this_msgID;
            };
        };

         # Case of filename attachments (2 Steps)
         # Sep  5 10:16:10 galadriel postfix/cleanup[1302]: 6B1E32A87CE: warning: header Content-Type: image/png;? name="pascal.salaun_nbAtt_.png" from unknown[192.168.1.4]; \
         # from=<frodon.saquet@laposte.net> to=<frodon.saquet@laposte.net> proto=ESMTP helo=<[192.168.1.4]>: ThisFileName=pascal.salaun_nbAtt_.png
         #

         # Case of filename attachments (2 Steps) : 1rst, collecting filename
         #             1         2      3        4                                   5                        6
         if( $_ =~ m%(.*)(postfix/.*)\[(\d+)\]: (.*): warning: header Content-Type: (.*);\?.*: ThisFileName=(.*).*% ) {
            $this_queueId = $4 ;
            
            if( exists $postfixId{$this_queueId} ) {
				$this_FileName = $6 ;
				$this_FileName =~ s/\?=// ;
				@mimetype = split(/\./,$this_FileName) ;
				#$this_mimetype = $5 ;
				#@mimetype = split("/",$this_mimetype) ;
					
				$filetype = lc(pop(@mimetype));
				if( length($filetype) == 0 || length($filetype)>6) {
					$filetype = 'unknown';
				};


				#$fileList{$4}{'filename'}{$this_FileName}=1;
				push@{$fileList{$this_queueId}{$filetype}},1 ; 
			};
         };


         # Case of originators and volume/mail
         # Aug 22 15:38:15 galadriel postfix/qmgr[4158]: 7E83C9E4318: from=<frodon.saquet@laposte.net>, size=1767, nrcpt=1 (queue active)
         #              1        2          3      4            5             6    
         if ( $_ =~ m%(.*)(postfix/.*)\[(\d+)\]: (.*): from=<(.*)>, size=(\d+), nrcpt=(\d+).*% ) {

           $this_queueId = $4 ;

			if( exists $postfixId{$this_queueId} ) {
				$this_nrcpt   = $7 ;
                $this_vol     = $6 ;
				$this_address = $5 ;
				my $thisMsgId = $postfixId{$this_queueId} ;
				my %thisFileList = %{$fileList{$this_queueId}} ;
				my $nbAtt  = "0" ;
				my $volAtt = "0" ;
				%thisFileExtentionListSum = () ;

				$list_vol_by_msgID{$postfixId{$this_queueId}} = $6 ;
				#print "From $this_address $this_vol "; 
				$this_gestionnaire = "" ;
				@prefixe = split(/\@/,$this_address);
				$superkey = $prefixe[0];
				$this_SenderDomain = $prefixe[1];
				# Case of Notification "from=<>" 
                
				if( ! $this_address ) {
					$this_SenderDomain = "Notification" ;
					$superkey = "Notification" ;
				};

				#$this_address =~ s/\@/\\\@/;

				$list_domain_by_postfixId{$thisMsgId} = $this_SenderDomain ;             

				my $this_Filename_ref = \%thisFileList ;
				($nbAtt, $volAtt, %thisFileExtentionListSum) =  &mailFileAttSummInfo($this_Filename_ref,$this_vol) ;
 

				my $this_nbfHKey  = "nbf".$this_hour ;
				my $this_volfHKey = "volf".$this_hour ;

				if ( exists $local_address{$this_address} ) {
					$this_gestionnaire = $local_address{$this_address};
					# Local Sender
					$localSender{$thisMsgId} = $this_gestionnaire ;
                    
					foreach my $thisExtension (keys %thisFileExtentionListSum) {
						push @{$compteur{$this_gestionnaire}{$superkey}{'mimetype'}{$thisExtension}}, $thisFileExtentionListSum{$thisExtension};
						push @{$compteur{$this_gestionnaire}{'mimetype'}{$thisExtension}}, $thisFileExtentionListSum{$thisExtension};
						push @{$compteur{'GlobalServer'}{'mimetype'}{$thisExtension}}, $thisFileExtentionListSum{$thisExtension};
					};
					
					#print "Interne : $this_address | $this_vol | $this_gestionnaire \n ";
					# Global counters for 1 address ($superkey) of $this_domain
					push @{$compteur{$this_gestionnaire}{$superkey}{'nbf'}},1;
					push @{$compteur{$this_gestionnaire}{$superkey}{'volf'}},$this_vol;
					push @{$compteur{$this_gestionnaire}{$superkey}{'nbAtt'}{$nbAtt}},1;
					push @{$compteur{$this_gestionnaire}{$superkey}{'volAtt'}{$volAtt}},1;
                    
					push @{$compteur{$this_gestionnaire}{'nbf'}},1;
					push @{$compteur{$this_gestionnaire}{'volf'}},$this_vol;
					push @{$compteur{$this_gestionnaire}{'nbAtt'}{$nbAtt}},1;
					push @{$compteur{$this_gestionnaire}{'volAtt'}{$volAtt}},1;
                    push @{$compteur{$this_gestionnaire}{'nbRcpt'}{$this_nrcpt}},1;
                    
                                
					push @{$compteur{'GlobalServer'}{'nbf'}},1;
					push @{$compteur{'GlobalServer'}{'volf'}},$this_vol;
					push @{$compteur{'GlobalServer'}{'nbAtt'}{$nbAtt}},1;
					push @{$compteur{'GlobalServer'}{'volAtt'}{$volAtt}},1;
                    #push @{$compteur{'GlobalServer'}{'nbRcpt'}{$this_nrcpt}},1; # has no sense 

					# hourly counters 
					push @{$compteur{$this_gestionnaire}{$this_nbfHKey}},1;
					push @{$compteur{$this_gestionnaire}{$this_volfHKey}},$this_vol;

					push @{$compteur{'GlobalServer'}{$this_nbfHKey}},1;
					push @{$compteur{'GlobalServer'}{$this_volfHKey}},$this_vol;

				} else { 

					#print "Externe : $this_address | $this_vol | xXx \n ";
					# Global counters for non-local address    
					push @{$compteur{'Externe'}{'nbf'} },1;
					push @{$compteur{'Externe'}{'volf'}},$this_vol;
					push @{$compteur{'Externe'}{'nbAtt'}{$nbAtt}},1;
					push @{$compteur{'Externe'}{'volAtt'}{$volAtt}},1;
                    push @{$compteur{'Externe'}{'nbRcpt'}{$this_nrcpt}},1;

					foreach my $thisExtension (keys %thisFileExtentionListSum) {
						push @{$compteur{'Externe'}{mimetype}{$thisExtension}}, $thisFileExtentionListSum{$thisExtension};
		    		};

		    		# hourly counters for non-local address                    
					push @{$compteur{'Externe'}{$this_nbfHKey} },1;
					push @{$compteur{'Externe'}{$this_volfHKey}},$this_vol;
				};
       
			};
         };

        # Case of destinators (successfull dsn=2.*.*)
        #               1     2       3     4        5          6      7                    
        if ( $_ =~ m%(.*)(postfix/)(.*)\[(\d+)\]: (.*): to=<(.*@.*)>, (.*)status=sent.*% ) {

            $this_queueId = $5 ;                
			my $to_block = $6 ;
        
			if( exists($postfixId{$this_queueId}) ) {

				#Case of "from a mailing-list"
				#frodon.saquet@laposte.net>, orig_to=<a-list-from-somewhere@list.obm.org
				my @sub_adr = split(/>,/,$to_block);
				$this_address = $sub_adr[0] ;
				my $thisMsgId = $postfixId{$this_queueId} ;

				@prefixe = split(/\@/,$sub_adr[0]);
				$superkey = $prefixe[0];
				$this_RecipDomain = $prefixe[1];
				#$this_address =~ s/\@/\\\@/;

				my $this_nbtHKey    = "nbt".$this_hour ;         
                my $this_nbTHKey    = "nbT".$this_hour ;
				my $this_voltHKey   = "volt".$this_hour ;
                 
                # Case of local domain sender (where  i write to)
				if ( exists $localSender{$thisMsgId} ) {
					$this_gestionnaire = $localSender{$thisMsgId} ;
					$recipDomainByGestionnaire{$this_gestionnaire}{$this_RecipDomain}{$thisMsgId} = $list_vol_by_msgID{$thisMsgId} ;
				};

				# Case of local recip
				if (exists $local_address{$this_address} ) {
                               
					$this_gestionnaire = $local_address{$this_address};  

					# Domain Sender Counters
					$thisSenderDomain = $list_domain_by_postfixId{$thisMsgId};
					$senderDomainByGestionnaire{$this_gestionnaire}{$thisSenderDomain}{$thisMsgId} = $list_vol_by_msgID{$thisMsgId} ;

                   # user counters
					push @{$compteur{$this_gestionnaire}{$superkey}{'nbr'}},1;
					push @{$compteur{$this_gestionnaire}{$superkey}{'volr'}},$list_vol_by_msgID{$thisMsgId};           

					# Global counters
					push @{$compteur{$this_gestionnaire}{'nbt'}},1 ;
					push @{$compteur{'GlobalServer'}{'nbt'}},1 ;
                    

                    push @{$compteur{$this_gestionnaire}{'volt'}}, $list_vol_by_msgID{$thisMsgId};
                    push @{$compteur{'GlobalServer'}{'volt'}}, $list_vol_by_msgID{$thisMsgId};

                    push @{$compteur{$this_gestionnaire}{'nbT'}},($thisMsgId => $list_vol_by_msgID{$thisMsgId}) ;
                    push @{$compteur{'GlobalServer'}{'nbT'}},($thisMsgId => $list_vol_by_msgID{$thisMsgId}) ;
          
					# hourly counters
					push @{$compteur{$this_gestionnaire}{$this_nbtHKey}},1 ;
					push @{$compteur{'GlobalServer'}{$this_nbtHKey}},1 ;

                    push @{$compteur{$this_gestionnaire}{$this_voltHKey}}, $list_vol_by_msgID{$thisMsgId};
                    push @{$compteur{'GlobalServer'}{$this_voltHKey}}, $list_vol_by_msgID{$thisMsgId};

                    push @{$compteur{$this_gestionnaire}{$this_nbTHKey}},($thisMsgId => $list_vol_by_msgID{$thisMsgId}) ;
                    push @{$compteur{'GlobalServer'}{$this_nbTHKey}},($thisMsgId => $list_vol_by_msgID{$thisMsgId}) ;

				} else { 
					# Global counters  
					push @{$compteur{'Externe'}{'nbt'}},1 ;
					push @{$compteur{'Externe'}{$this_nbtHKey}},1 ;

                    push @{$compteur{'Externe'}{'nbT'}},($thisMsgId => $list_vol_by_msgID{$thisMsgId}) ;
                    push @{$compteur{'Externe'}{$this_nbTHKey}},($thisMsgId => $list_vol_by_msgID{$thisMsgId}) ;
				};
			};    
        };


        # Case of destinator deferred (dsn=4.*.*)
        #              1      2      3     4       5           6           7      8
        if ( $_ =~ m%(.*)(postfix/)(.*)\[(\d+)\]: (.*): to=<(.*@.*)>, (relay=.*)?(.*)status=deferred.*% )  {
            $this_queueId = $5 ;
            
            $this_address = $6 ;
			@prefixe = split(/\@/,$this_address);
			$superkey = $prefixe[0];
			#$this_address =~ s/\@/\\\@/;
			my $this_deferredHKey = "deferred".$this_hour ;

			# Parse only once for a message "deferred" (dsn=4.*.*)       
			if($all_queueid{$this_queueId} == 0 ) {    
				if (exists $local_address{$this_address} ) {
                
					$this_gestionnaire = $local_address{$this_address};   
					push @{$compteur{$this_gestionnaire}{'deferred'}},1 ;
					push @{$compteur{$this_gestionnaire}{$this_deferredHKey}},1 ;
                       
					push @{$compteur{'GlobalServer'}{'deferred'}},1 ;                      
					push @{$compteur{'GlobalServer'}{$this_deferredHKey}},1 ;
                
				}  else {                
					push @{$compteur{'Externe'}{'deferred'}},1 ;                     
					push @{$compteur{'Externe'}{$this_deferredHKey}},1 ;   
				};
                
				# set it as treated
				$all_queueid{$this_queueId} = 1 ;

			} else {
			};
        };
        
        # Case of destinator bounced (dsn=4.*.*)
        #              1     2       3      4       5          6            7     8
        if ( $_ =~ m%(.*)(postfix/)(.*)\[(\d+)\]: (.*): to=<(.*@.*)>, (relay=.*)?(.*)status=bounced.*% ) {
			$this_address = $6 ;
			@prefixe = split(/\@/,$this_address);
			$superkey = $prefixe[0];
			#$this_address =~ s/\@/\\\@/;

			my $this_bouncedHKey = "bounced".$this_hour ;              
			if ($local_address{$this_address} ) {

				$this_gestionnaire = $local_address{$this_address};   
                      
				push @{$compteur{$this_gestionnaire}{'bounced'}},1 ;
				push @{$compteur{$this_gestionnaire}{$this_bouncedHKey}},1 ;
                        
				push @{$compteur{'GlobalServer'}{'bounced'}},1 ;                      
				push @{$compteur{'GlobalServer'}{$this_bouncedHKey}},1 ;

			} else {
				push @{$compteur{'Externe'}{'bounced'}},1 ;                      
				push @{$compteur{'Externe'}{$this_bouncedHKey}},1 ;
			};
        };
    };
};

close(F) ;

#print Dumper(\\ %compteur) ;






#
# Making from %compteur the XML files
#


my $xml_date = &date_du_parse($date);

foreach my $domain (keys(%compteur)) {
    # Stats globales et communes pour toutes les entitees.
    # Les fichiers remplacent ce qui etaient avant dans une DB
    if ($domain =~ m%[a-zA-Z0-9]+%) { &alimGeneralStatFile($date,$domain) ; };


    if( ($domain =~ m%[a-zA-Z0-9]+%) and ($domain ne "Externe") and ($domain ne "GlobalServer") ) {

        my %thisArray = %{$senderDomainByGestionnaire{$domain}} ;
        my %thisArrayOutgoing = %{$recipDomainByGestionnaire{$domain}};

        my $this_xml_dir = $path_to_data_dir.$domain."/xml";
        my $this_xmlGlobalDomain_dir = $path_to_data_dir.$domain."/xmlGlobalDomain";
        my $this_xmlGlobalDomainOutgoing_dir = $path_to_data_dir.$domain."/xmlGlobalDomainOutgoing";
        
        my $this_user_dir  = $path_to_data_dir.$domain."/user" ;
       
        &control_rep($this_xml_dir);
        &control_rep("$this_xml_dir/resume");

        &control_rep($this_xmlGlobalDomain_dir);
        &control_rep("$this_xmlGlobalDomain_dir/resume");
        
        &control_rep($this_xmlGlobalDomainOutgoing_dir);
        &control_rep("$this_xmlGlobalDomainOutgoing_dir/resume");

        &control_rep($this_user_dir);


        ## Daily xml file
        #    
        my $this_daily_xml_file = $this_xml_dir."/".$xml_date.".xml";
        my $this_daily_xmlGlobalDomain_file = $this_xmlGlobalDomain_dir."/".$xml_date.".xml";
        my $this_daily_xmlGlobalDomainOutgoing_file = $this_xmlGlobalDomainOutgoing_dir."/".$xml_date.".xml";

        my @user = keys %{@compteur{$domain}};

        open(FStatd,"> $this_daily_xml_file") || die "Error while opening : $!";
       
        ## Stat by user sender (= top50 des users du domaine)
        #XML Header
        print FStatd "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
        print FStatd " <statsbyuser>\n";

        foreach my $this_user (sort @user) {

            if( ($this_user=~ m%[a-zA-Z0-9]+%) and ($this_user !~ m%(nbt|nbf|nbT|nbRcpt|volf|nbr|volt|volr|nbAtt|volAtt|bounced|deferred|mimetype)\d{0,2}% ) ) {
               
     			my $this_user_file = $this_user_dir."/".$this_user ; 

                #print  $this_user." \n";

				## figures
				my %userFigures = (
						'nbf'=> '0',
						'volf'=> '0',
						'nbr'=> '0',
						'volr'=> '0',
						'nbAtt0'=> '0',
						'nbAtt1'=> '0',
						'nbAtt2'=> '0',
						'nbAtt3'=> '0',
						'nbAtt4'=> '0',
						'nbAtt5'=> '0',
						'nbAtt6'=> '0',
						'volAtt100'=> '0',
						'volAtt200'=> '0',
						'volAtt500'=> '0',						
						'volAtt1M'=> '0',
						'volAtt2M'=> '0',
						'volAtt3M'=> '0',
						'volAtt4M'=> '0',
						'volAtt5M'=> '0',
						'volAtt6M'=> '0',
						'mimetype' => '',
						'mimetype' => ''
				) ; 

				$userFigures{'nbf'} = sum( @{$compteur{$domain}{$this_user}{'nbf'}} );
        		$userFigures{'volf'} = sum( @{$compteur{$domain}{$this_user}{'volf'}} );
				$userFigures{'nbr'} = sum( @{$compteur{$domain}{$this_user}{'nbr'}} );
				$userFigures{'volr'} = sum( @{$compteur{$domain}{$this_user}{'volr'}} );
				
				foreach $nbAttCase (@indexNbAtt) {
					my $caseIndex = "nbAtt".$nbAttCase ;					
					$userFigures{$caseIndex} = sum( @{$compteur{$domain}{$this_user}{'nbAtt'}{$nbAttCase}});									
				};

				foreach $volAttCase (@indexVolAtt) {
					my $caseIndex = "volAtt".$volAttCase ;					
					$userFigures{$caseIndex} = sum( @{$compteur{$domain}{$this_user}{'volAtt'}{$volAttCase}});									
				};
				
				my @tempArray = () ;
               foreach $thisUserFileMimetype (keys %{$compteur{$domain}{$this_user}{'mimetype'}} ) {
					my $thisMimeSum = 0;
					$thisMimeSum = sum (@{$compteur{$domain}{$this_user}{'mimetype'}{$thisUserFileMimetype}}) ;
					push @tempArray, $thisUserFileMimetype.":".$thisMimeSum;
				};

				$userFigures{'mimetype'} = join (";",@tempArray) ;
 

				my $thisUserValRef = \%userFigures ;	
			
				## user file stat
				my $this_user_file = $this_user_dir."/".$this_user ;
				&alimUserFileStat($thisUserValRef,$this_user_file,$timestamp);
            
                my $thisUserSent = $userFigures{'nbf'} + 0 ;
                my $thisUserVol  = $userFigures{'volf'} + 0 ;
				## XML Part. 
				print FStatd "  <user>\n";
				print FStatd "   <name>$this_user</name>\n";
				print FStatd "   <mailSent>$thisUserSent</mailSent>\n";
				print FStatd "   <mailSentTotalSize>$thisUserVol</mailSentTotalSize>\n";
				print FStatd "  </user>\n";
            };
        };

        print FStatd " </statsbyuser>\n";
        close FStatd || die "Error while closing : $!";


        ## Stat by domain sender (= domaine qui m'envoie)
        open(FStatd,"> $this_daily_xmlGlobalDomain_file") || die "Error while opening : $!";
        #XML Header
        print FStatd "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
        print FStatd " <statsbyuser>\n";
        
        foreach my $thisSenderDomain (keys(%thisArray)) {
            my @thisArray  = values(%{$thisArray{$thisSenderDomain}});
            my $nbSentMessage = @thisArray;
            my $volSentMessage= sum(@thisArray);
            
            ## XML Part. 
            print FStatd "  <user>\n";
            print FStatd "   <name>$thisSenderDomain</name>\n";
            print FStatd "   <mailSent>$nbSentMessage</mailSent>\n";
            print FStatd "   <mailSentTotalSize>$volSentMessage</mailSentTotalSize>\n";
            print FStatd "  </user>\n";
        };

        print FStatd " </statsbyuser>\n";
        close FStatd || die "Error while closing : $!";

        ## Stat by domain recip (= domaine a qui j'envoie)
        open(FStatd,"> $this_daily_xmlGlobalDomainOutgoing_file") || die "Error while opening : $!";
        #XML Header
        print FStatd "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
        print FStatd " <statsbyuser>\n";

        foreach my $thisRecipDomain (keys(%thisArrayOutgoing)) {
                my @thisArray  = values(%{$thisArrayOutgoing{$thisRecipDomain}});
                my $nbSentMessage = @thisArray;
                my $volSentMessage= sum(@thisArray);

                ## XML Part.
                print FStatd "  <user>\n";
                print FStatd "   <name>$thisRecipDomain</name>\n";
                print FStatd "   <mailSent>$nbSentMessage</mailSent>\n";
                print FStatd "   <mailSentTotalSize>$volSentMessage</mailSentTotalSize>\n";
                print FStatd "  </user>\n";
        };

        print FStatd " </statsbyuser>\n";
        close FStatd || die "Error while closing : $!";

        
        # do a resume (50 max)
        &do_resume_this_file($this_daily_xml_file);
        &do_resume_this_file($this_daily_xmlGlobalDomain_file);
        &do_resume_this_file($this_daily_xmlGlobalDomainOutgoing_file);

        #
        ## End of Daily xml file
    




        # Why do i xml file, each day, for this week, this month and this year ?
        # Because, over 7 parsed files, the server "could be" out of memory
        # Citation : "Non merci, j'ai les dents du fond qui baignent" (TMP)

        ## Weekly xml file
        #
        my $week = Week_Number($an,$mois,$jour_mois);
        if( $week == 0 ) {
            $week = Week_Number($an-1,12,31);
        };
        my $file_stat_week_name = `date --date '1 day ago' +%Y_%m_`;
        chomp($file_stat_week_name);
        $file_stat_week_name .= $week.".xml";

        my $this_weekly_xml_file = $this_xml_dir."/".$file_stat_week_name ;
        my $this_weekly_xmlGlobalDomain_file = $this_xmlGlobalDomain_dir."/".$file_stat_week_name ;
        my $this_weekly_xmlGlobalDomainOutgoing_file = $this_xmlGlobalDomainOutgoing_dir."/".$file_stat_week_name ;

        ## Stat by user sender
        if( ! -e $this_weekly_xml_file ) {
            copy("$this_daily_xml_file","$this_weekly_xml_file");
            &do_resume_this_file($this_weekly_xml_file);
        } else {
            
            # parsing the previous day (yesterday) 
            my %new_array  = ();
            my $newArrayWeekRef = \%new_array ;
            &my_xml_parser($this_daily_xml_file,"$newArrayWeekRef");

            # parsing these weekly xml generated each day before
            &my_xml_parser($this_weekly_xml_file,"$newArrayWeekRef");

            &write_this_to_xml("$this_weekly_xml_file","$newArrayWeekRef");
        };

        ## Stat by domain sender
        if( ! -e $this_weekly_xmlGlobalDomain_file ) {
            copy("$this_daily_xmlGlobalDomain_file","$this_weekly_xmlGlobalDomain_file");
            &do_resume_this_file($this_weekly_xmlGlobalDomain_file);
        } else {

            # parsing the previous day (yesterday)
            my %new_array  = ();
            my $newArrayWeekRef = \%new_array ;
            &my_xml_parser($this_daily_xmlGlobalDomain_file,"$newArrayWeekRef");

            # parsing these weekly xml generated each day before
            &my_xml_parser($this_weekly_xmlGlobalDomain_file,"$newArrayWeekRef");

            &write_this_to_xml("$this_weekly_xmlGlobalDomain_file","$newArrayWeekRef");
        };

        ## Stat by domain recip
        if( ! -e $this_weekly_xmlGlobalDomainOutgoing_file ) {
            copy("$this_daily_xmlGlobalDomainOutgoing_file","$this_weekly_xmlGlobalDomainOutgoing_file");
            &do_resume_this_file($this_weekly_xmlGlobalDomainOutgoing_file);
        } else {

            # parsing the previous day (yesterday)
            my %new_array  = ();
            my $newArrayWeekRef = \%new_array ;
            &my_xml_parser($this_daily_xmlGlobalDomainOutgoing_file,"$newArrayWeekRef");

            # parsing these weekly xml generated each day before
            &my_xml_parser($this_weekly_xmlGlobalDomainOutgoing_file,"$newArrayWeekRef");

            &write_this_to_xml("$this_weekly_xmlGlobalDomainOutgoing_file","$newArrayWeekRef");

        };

        #
        ## End of Weekly xml file


        ## Monthly xml file
        #

        my $file_stat_month_name = `date --date '1 day ago' +%Y_%m`;
        chomp($file_stat_month_name);
        $file_stat_month_name .=".xml";

        my $this_monthly_xml_file = $this_xml_dir."/".$file_stat_month_name ;
        my $this_monthly_xmlGlobalDomain_file = $this_xmlGlobalDomain_dir."/".$file_stat_month_name ;
        my $this_monthly_xmlGlobalDomainOutgoing_file = $this_xmlGlobalDomainOutgoing_dir."/".$file_stat_month_name ;


        ## Stat by user sender
        if( ! -e $this_monthly_xml_file ) {
            copy("$this_daily_xml_file","$this_monthly_xml_file");
            &do_resume_this_file($this_monthly_xml_file);
        } else {

            # parsing the previous day (yesterday)
            my %new_array  = ();
            my $newArrayWeekRef = \%new_array ;
            &my_xml_parser($this_daily_xml_file,"$newArrayWeekRef");

            # parsing these monthly xml generated each day before
            &my_xml_parser($this_monthly_xml_file,"$newArrayWeekRef");

            &write_this_to_xml("$this_monthly_xml_file","$newArrayWeekRef");

        };

        ## Stat by domain sender
        if( ! -e $this_monthly_xmlGlobalDomain_file ) {
            copy("$this_daily_xmlGlobalDomain_file","$this_monthly_xmlGlobalDomain_file");
            &do_resume_this_file($this_monthly_xmlGlobalDomain_file);
        } else {

            # parsing the previous day (yesterday)
            my %new_array  = ();
            my $newArrayWeekRef = \%new_array ;
            &my_xml_parser($this_daily_xmlGlobalDomain_file,"$newArrayWeekRef");

            # parsing these monthly xml generated each day before
            &my_xml_parser($this_monthly_xmlGlobalDomain_file,"$newArrayWeekRef");

            &write_this_to_xml("$this_monthly_xmlGlobalDomain_file","$newArrayWeekRef");

        };

        ## Stat by domain recip
        if( ! -e $this_monthly_xmlGlobalDomainOutgoing_file ) {
            copy("$this_daily_xmlGlobalDomainOutgoing_file","$this_monthly_xmlGlobalDomainOutgoing_file");
            &do_resume_this_file($this_monthly_xmlGlobalDomainOutgoing_file);
        } else {

            # parsing the previous day (yesterday)
            my %new_array  = ();
            my $newArrayWeekRef = \%new_array ;
            &my_xml_parser($this_daily_xmlGlobalDomainOutgoing_file,"$newArrayWeekRef");

            # parsing these monthly xml generated each day before
            &my_xml_parser($this_monthly_xmlGlobalDomainOutgoing_file,"$newArrayWeekRef");

            &write_this_to_xml("$this_monthly_xmlGlobalDomainOutgoing_file","$newArrayWeekRef");

        };
        #
        ## End of Monthly xml file


        ## Yearly xml file
        #

        # Init table
        my $file_stat_year_name = `date --date '1 day ago' +%Y`;
        chomp($file_stat_year_name);
        $file_stat_year_name .=".xml";
        my $this_yearly_xml_file =  $this_xml_dir."/".$file_stat_year_name ;
        my $this_yearly_xmlGlobalDomain_file =  $this_xmlGlobalDomain_dir."/".$file_stat_year_name ;
        my $this_yearly_xmlGlobalDomainOutgoing_file =  $this_xmlGlobalDomainOutgoing_dir."/".$file_stat_year_name ;

        ## Stat by user sender
        if( ! -e $this_yearly_xml_file ) {
            copy("$this_daily_xml_file","$this_yearly_xml_file");
            &do_resume_this_file($this_yearly_xml_file);
        } else {

            # parsing the previous day (yesterday)
            my %new_array  = ();
            my $newArrayWeekRef = \%new_array ;
            &my_xml_parser($this_daily_xml_file,"$newArrayWeekRef");

            # parsing these monthly xml generated each day before
            &my_xml_parser($this_yearly_xml_file,"$newArrayWeekRef");

            &write_this_to_xml("$this_yearly_xml_file","$newArrayWeekRef");

        };

        ## Stat by domain sender
        if( ! -e $this_monthly_xmlGlobalDomain_file ) {
            copy("$this_daily_xmlGlobalDomain_file","$this_yearly_xmlGlobalDomain_file");
            &do_resume_this_file($this_yearly_xmlGlobalDomain_file);
        } else {

            # parsing the previous day (yesterday)
            my %new_array  = ();
            my $newArrayWeekRef = \%new_array ;
            &my_xml_parser($this_daily_xmlGlobalDomain_file,"$newArrayWeekRef");

            # parsing these monthly xml generated each day before
            &my_xml_parser($this_yearly_xmlGlobalDomain_file,"$newArrayWeekRef");

            &write_this_to_xml("$this_yearly_xmlGlobalDomain_file","$newArrayWeekRef");

        };

        ## Stat by domain recip
        if( ! -e $this_monthly_xmlGlobalDomainOutgoing_file ) {
            copy("$this_daily_xmlGlobalDomainOutgoing_file","$this_yearly_xmlGlobalDomainOutgoing_file");
            &do_resume_this_file($this_yearly_xmlGlobalDomainOutgoing_file);
        } else {

            # parsing the previous day (yesterday)
            my %new_array  = ();
            my $newArrayWeekRef = \%new_array ;
            &my_xml_parser($this_daily_xmlGlobalDomainOutgoing_file,"$newArrayWeekRef");

            # parsing these monthly xml generated each day before
            &my_xml_parser($this_yearly_xmlGlobalDomainOutgoing_file,"$newArrayWeekRef");

            &write_this_to_xml("$this_yearly_xmlGlobalDomainOutgoing_file","$newArrayWeekRef");

        };

        #
        ## End of Yearly xml file

    };
};


