#!/usr/bin/php5
<?php

/* Fichier de conf/fonctions */
require("/usr/share/bm-stats/www/conf/config.php");
require("/usr/share/bm-stats/www/function/date.php");
require("/usr/share/bm-stats/www/function/lang.php");


/* Variables modifiables*/
$path_to_pChart = "/usr/share/bm-stats/scripts/PHP/pChart/" ;
$dataFile = "/var/lib/bm-stats/general/domainDSNStat.dat";




/* DO NOT TOUCH AFTER */
if(date("z") == "0" ) { 
    $this_year = date("Y") - 1 ; 
} else { 
    $this_year = date("Y"); 
};


$mktime_yesterday = mktime(0,0,0,date("m"),date("d")-1,date("y"));
$this_year  = date("Y",$mktime_yesterday);
$this_week  = date("W",$mktime_yesterday);
$this_month = date("m",$mktime_yesterday);
$this_n_day   = date("z",$mktime_yesterday);        
        
/* JOB */

// Recup. des donnees 
$values = get_values() ;


// Creation des images
foreach (array_keys($values) as $domain) {

    if($domain != "date" and $domain != "GlobalServer" and $domain != "Externe" and $domain != "d" and $domain != "w") {
        $myLang = getLang($domain) ;
        if(!empty($myLang)) $lang=$myLang ;

        require("/usr/share/bm-stats/www/inc_lang/inc_lang_$lang.php");
        /* Liste des titres dans les graphes */
        $list_title['deferred']['title']   = $do_graph_error_deferred_title;
        $list_title['bounced']['title']    = $do_graph_error_bounced_title;

        $this_lit_month = get_month($this_month); 
        $this_full_day = date("d",$mktime_yesterday)." ".$this_lit_month." ".$this_year;

        $case_img = array(  
                    "deferred" => array(    
                            "titley" => "$do_graph_error_deferred_titley $this_year",
                            "titlem" => "$do_graph_error_deferred_titlem $this_lit_month $this_year",
                            "titlew" => "$do_graph_error_deferred_titlew $this_week ($this_year)",
                            "titled" => "$do_graph_error_deferred_titled $this_full_day "
                            ),
                    "bounced" => array( 
                            "titley"=> "$do_graph_error_bounced_titley $this_year",
                            "titlem"=> "$do_graph_error_bounced_titlem $this_lit_month $this_year",
                            "titlew"=> "$do_graph_error_bounced_titlew $this_week ($this_year)",
                            "titled"=> "$do_graph_error_bounced_titled $this_full_day "
                            )
                   );

    
        foreach(array_keys($case_img) as $case) {
            if(count($values[$domain]['y'][$case])) {
                do_img($values,$domain,$case,"y") ;
            };

            if(count($values[$domain]['m'][$case]) >1 ) {   
                do_img($values,$domain,$case,"m") ;
            };

            if(count($values[$domain]['w'][$case]) >1 ) {
                do_img($values,$domain,$case,"w") ;
            };

            if(count($values[$domain]['d'][$case]) >1 ) {
                do_img($values,$domain,$case,"d") ;
            };
        };
    };
};

/* DO NOT TOUCH AFTER */

/* Debut des fonctions locales */

function verif_existence_rep($rep) {
 	$PATH=$rep;

	if(!(is_dir($PATH))){
        	$cmd = "mkdir -p $PATH ; chmod -R 755 $PATH  ; chown -R root.www-data $PATH";
        	exec($cmd);
	} else {
		$cmd = "chmod -R 755 $PATH ; chown -R root.www-data $PATH ";
		exec($cmd);
	};
};

function SetXScaleDate($value)  {
	$jour = substr($value,8,2);
	$mois = substr($value,5,2);

	if($jour == "01") {
		$xscaled = $jour." ".get_month($mois) ;
	} else {	
		$xscaled = " " ;
	};
		
	return $xscaled ;
};





function get_values() {
	Global $this_year,$this_week,$this_month,$this_n_day,$dataFile  ; 	

        $first_date_passed = "0" ;

	$values = array() ;
        $values['d']['hour']= array("00:59","01:59","02:59","03:59","04:59","05:59","06:59","07:59","08:59","09:59","10:59","11:59","12:59","13:59","14:59","15:59","16:59","17:59","18:59","19:59","20:59","21:59","22:59","23:59") ;
	$values['w']['hour']= array(
					"L 00"," "," "," "," "," "," "," "," "," "," "," ","L 12"," "," "," "," "," "," "," "," "," "," ","",
					"M 00"," "," "," "," "," "," "," "," "," "," "," ","M 12"," "," "," "," "," "," "," "," "," "," ","",
					"M 00"," "," "," "," "," "," "," "," "," "," "," ","M 12"," "," "," "," "," "," "," "," "," "," ","",
					"J 00"," "," "," "," "," "," "," "," "," "," "," ","J 12"," "," "," "," "," "," "," "," "," "," ","",	
					"V 00"," "," "," "," "," "," "," "," "," "," "," ","V 12"," "," "," "," "," "," "," "," "," "," ","",
					"S 00"," "," "," "," "," "," "," "," "," "," "," ","S 12"," "," "," "," "," "," "," "," "," "," ","",
					"D 00"," "," "," "," "," "," "," "," "," "," "," ","D 12"," "," "," "," "," "," "," "," "," "," ",""
					) ;

	



    $data = file($dataFile);
    sort($data); 
    foreach($data as $line) {

        if(preg_match("/^$this_year/",$line)) {

            $val = explode(",",$line);
		    $date = $val['0'];
		 	$this_X_dot = SetXScaleDate($date);
			$element = explode("-",$date);
		 	$element_year   = $element[0];		 
		 	$element_month  = $element[1];
		 	$element_day    = $element[2];		 			
		 	$element_mktime = mktime(0,0,0,$element_month,$element_day,$element_year) ;
		 	$element_n_day	 = date("z",$element_mktime);
		 	$element_week   = date("W",$element_mktime);
            $element_num_day_of_week = date("N",$element_mktime) ;
                        
			$domain   = $val['1'];
			$deferred = $val['2'];
			$bounced  = $val['27'];
  
			$values[$domain]['y']['date'][]     = $this_X_dot ;
			$values[$domain]['y']['deferred'][] = $deferred ;
			$values[$domain]['y']['bounced'][]  = $bounced ;
		


		    if( ($this_year==$element_year) and  ($this_month==$element_month) ) {		
			    $values[$domain]['m']['date'][] = $element_day;
			    $values[$domain]['m']['deferred'][]     = $deferred ;
			    $values[$domain]['m']['bounced'][]    = $bounced ;

		    };

		    if( ($this_year==$element_year) and  ($this_week==$element_week) ) {		
                if($first_date_passed =="0") {
                    if($element_num_day_of_week >= 2 ) {
                        $pos = ($element_num_day_of_week - 1)*24 ;
                        $new_values = array_splice($values['w']['hour'],$pos);
                        $values['w']['hour'] = $new_values ;
                    };
                    $first_date_passed = "1" ;
                };

			    $values[$domain]['w']['date'][] = $element_day;
			    $values[$domain]['w']['deferred'][] = $val['3'];
			    $values[$domain]['w']['deferred'][] = $val['4'];
			    $values[$domain]['w']['deferred'][] = $val['5'];
			    $values[$domain]['w']['deferred'][] = $val['6'];
			    $values[$domain]['w']['deferred'][] = $val['7'];
			    $values[$domain]['w']['deferred'][] = $val['8'];
			    $values[$domain]['w']['deferred'][] = $val['9'];
			    $values[$domain]['w']['deferred'][] = $val['10'];
			    $values[$domain]['w']['deferred'][] = $val['11'];
			    $values[$domain]['w']['deferred'][] = $val['12'];
			    $values[$domain]['w']['deferred'][] = $val['13'];
			    $values[$domain]['w']['deferred'][] = $val['14'];
			    $values[$domain]['w']['deferred'][] = $val['15'];
			    $values[$domain]['w']['deferred'][] = $val['16'];
			    $values[$domain]['w']['deferred'][] = $val['17'];
			    $values[$domain]['w']['deferred'][] = $val['18'];
			    $values[$domain]['w']['deferred'][] = $val['19'];
			    $values[$domain]['w']['deferred'][] = $val['20'];
			    $values[$domain]['w']['deferred'][] = $val['21'];
			    $values[$domain]['w']['deferred'][] = $val['22'];
			    $values[$domain]['w']['deferred'][] = $val['23'];
			    $values[$domain]['w']['deferred'][] = $val['24'];
			    $values[$domain]['w']['deferred'][] = $val['25'];
			    $values[$domain]['w']['deferred'][] = $val['26'];

			    $values[$domain]['w']['bounced'][] = $val['28'];
			    $values[$domain]['w']['bounced'][] = $val['29'];
			    $values[$domain]['w']['bounced'][] = $val['30'];
			    $values[$domain]['w']['bounced'][] = $val['31'];
			    $values[$domain]['w']['bounced'][] = $val['32'];
			    $values[$domain]['w']['bounced'][] = $val['33'];
			    $values[$domain]['w']['bounced'][] = $val['34'];
			    $values[$domain]['w']['bounced'][] = $val['35'];
			    $values[$domain]['w']['bounced'][] = $val['36'];
			    $values[$domain]['w']['bounced'][] = $val['37'];
			    $values[$domain]['w']['bounced'][] = $val['38'];
			    $values[$domain]['w']['bounced'][] = $val['39'];
			    $values[$domain]['w']['bounced'][] = $val['40'];
			    $values[$domain]['w']['bounced'][] = $val['41'];
			    $values[$domain]['w']['bounced'][] = $val['42'];
			    $values[$domain]['w']['bounced'][] = $val['43'];
			    $values[$domain]['w']['bounced'][] = $val['44'];
			    $values[$domain]['w']['bounced'][] = $val['45'];
			    $values[$domain]['w']['bounced'][] = $val['46'];
			    $values[$domain]['w']['bounced'][] = $val['47'];
			    $values[$domain]['w']['bounced'][] = $val['48'];
			    $values[$domain]['w']['bounced'][] = $val['49'];
			    $values[$domain]['w']['bounced'][] = $val['50'];
			    $values[$domain]['w']['bounced'][] = $val['51'];

		    };

		    if( ($this_year==$element_year) and  ($this_n_day==$element_n_day) ) {	
			    $values[$domain]['d']['deferred'][] = $val['3'];
			    $values[$domain]['d']['deferred'][] = $val['4'];
			    $values[$domain]['d']['deferred'][] = $val['5'];
			    $values[$domain]['d']['deferred'][] = $val['6'];
			    $values[$domain]['d']['deferred'][] = $val['7'];
			    $values[$domain]['d']['deferred'][] = $val['8'];
			    $values[$domain]['d']['deferred'][] = $val['9'];
			    $values[$domain]['d']['deferred'][] = $val['10'];
			    $values[$domain]['d']['deferred'][] = $val['11'];
			    $values[$domain]['d']['deferred'][] = $val['12'];
			    $values[$domain]['d']['deferred'][] = $val['13'];
			    $values[$domain]['d']['deferred'][] = $val['14'];
			    $values[$domain]['d']['deferred'][] = $val['15'];
			    $values[$domain]['d']['deferred'][] = $val['16'];
			    $values[$domain]['d']['deferred'][] = $val['17'];
			    $values[$domain]['d']['deferred'][] = $val['18'];
			    $values[$domain]['d']['deferred'][] = $val['19'];
			    $values[$domain]['d']['deferred'][] = $val['20'];
			    $values[$domain]['d']['deferred'][] = $val['21'];
			    $values[$domain]['d']['deferred'][] = $val['22'];
			    $values[$domain]['d']['deferred'][] = $val['23'];
			    $values[$domain]['d']['deferred'][] = $val['24'];
			    $values[$domain]['d']['deferred'][] = $val['25'];
			    $values[$domain]['d']['deferred'][] = $val['26'];

			    $values[$domain]['d']['bounced'][] = $val['28'];
			    $values[$domain]['d']['bounced'][] = $val['29'];
			    $values[$domain]['d']['bounced'][] = $val['30'];
			    $values[$domain]['d']['bounced'][] = $val['31'];
			    $values[$domain]['d']['bounced'][] = $val['32'];
			    $values[$domain]['d']['bounced'][] = $val['33'];
			    $values[$domain]['d']['bounced'][] = $val['34'];
			    $values[$domain]['d']['bounced'][] = $val['35'];
			    $values[$domain]['d']['bounced'][] = $val['36'];
			    $values[$domain]['d']['bounced'][] = $val['37'];
			    $values[$domain]['d']['bounced'][] = $val['38'];
			    $values[$domain]['d']['bounced'][] = $val['39'];
			    $values[$domain]['d']['bounced'][] = $val['40'];
			    $values[$domain]['d']['bounced'][] = $val['41'];
			    $values[$domain]['d']['bounced'][] = $val['42'];
			    $values[$domain]['d']['bounced'][] = $val['43'];
			    $values[$domain]['d']['bounced'][] = $val['44'];
			    $values[$domain]['d']['bounced'][] = $val['45'];
			    $values[$domain]['d']['bounced'][] = $val['46'];
			    $values[$domain]['d']['bounced'][] = $val['47'];
			    $values[$domain]['d']['bounced'][] = $val['48'];
			    $values[$domain]['d']['bounced'][] = $val['49'];
			    $values[$domain]['d']['bounced'][] = $val['50'];
			    $values[$domain]['d']['bounced'][] = $val['51'];

		    };
	    };
    };
	return $values;
}; 


function setMo($value) 
{
	return round($value).' Mo';
};

function setRoundValue($value)
{
        return round($value) ;
};



/*
array $values : extraction de la tables MySQL faite par get_values().
$domain       : autre que GlobalServer & Externe
$case         : deferred,bounced,bouncedvol (entrant, sortant,volume sortant)

*/
function do_img(&$values,$domain,$case,$type)
{
    Global $this_year,$this_week,$this_month,$this_n_day  ;
	Global $path_to_data,$path_to_pChart,$case_img;		
	Global $do_graph_domain, $do_graph_global_server, $do_graph_external_server;
	
	$path_to_img = $path_to_data.$domain."/img/".$this_year."/";
	
    // Ctrl existance du dossier image
	verif_existence_rep($path_to_img);
    
    /* pChart library inclusions */
	require_once $path_to_pChart."class/pData.class.php";
    require_once $path_to_pChart."class/pDraw.class.php";
    require_once $path_to_pChart."class/pImage.class.php";

    $y1_title = $do_graph_domain." $domain ";
    $y2_title = $do_graph_global_server;
    $y3_title = $do_graph_external_server;

	if($type=="y")
	{
		$x  = $values[$domain]['y']['date'];
		$y1 = $values[$domain]['y'][$case];
		$y2 = $values['GlobalServer']['y'][$case];
    		$y3 = $values['Externe']['y'][$case];
		$title    = $case_img[$case]['titley'] ;
		$img = $path_to_img."Y".$this_year."_".$case.".png" ;
	};

	if($type=="m")
	{
		$x  = $values[$domain]['m']['date'];
		$y1 = $values[$domain]['m'][$case];
		$y2 = $values['GlobalServer']['m'][$case];
    		$y3 = $values['Externe']['m'][$case];
		$title    = $case_img[$case]['titlem'] ;
		$img = $path_to_img."M".$this_month."_".$case.".png" ;
	};

	if($type=="w")
	{
		$x  = $values['w']['hour'];
		$y1 = $values[$domain]['w'][$case];
		$y2 = $values['GlobalServer']['w'][$case];
    		$y3 = $values['Externe']['w'][$case];
		$title    = $case_img[$case]['titlew'] ;
		$img = $path_to_img."W".$this_week."_".$case.".png" ;
	};

	if($type=="d")
	{
		$x  = $values['d']['hour'];
		$y1 = $values[$domain]['d'][$case];
		$y2 = $values['GlobalServer']['d'][$case];
    		$y3 = $values['Externe']['d'][$case];
		$title    = $case_img[$case]['titled'] ;
		$img = $path_to_img."D".$this_n_day."_".$case.".png" ;
	};

		


	/* Create and populate the pData object */
    $MyData = new pData();

    $MyData->addPoints($y1,$y1_title);
    $y1_colorscheme = array("R"=>15,"G"=>44,"B"=>52,"Alpha"=>80);
    $MyData->setPalette($y1_title,$y1_colorscheme);

	$compArray = array_diff($y1 ,$y2);
	if(!empty($compArray)) {
        $MyData->addPoints($y2,$y2_title);
        $y2_colorscheme = array("R"=>184,"G"=>0,"B"=>40,"Alpha"=>80);
        $MyData->setPalette($y2_title,$y2_colorscheme);
	};

    $MyData->addPoints($y3,$y3_title);
    $y3_colorscheme = array("R"=>240,"G"=>165,"B"=>40,"Alpha"=>80);
    $MyData->setPalette($y3_title,$y3_colorscheme);


    $MyData->addPoints($x,"Labels");
    $MyData->setSerieDescription("Labels","Month");
    $MyData->setAbscissa("Labels");

    /* Create the pChart object */
    $myPicture = new pImage(1000,300,$MyData);
      
        $myPicture->drawGradientArea(0,0,1000,300,DIRECTION_VERTICAL,array("StartR"=>166,"StartG"=>202,"StartB"=>219,"EndR"=>0,"EndG"=>75,"EndB"=>123,"Alpha"=>100));
        $myPicture->drawGradientArea(0,250,1000,300,DIRECTION_VERTICAL,array("StartR"=>0,"StartG"=>75,"StartB"=>123,"EndR"=>166,"EndG"=>202,"EndB"=>219,"Alpha"=>100));


	$myPicture->drawLine(0,249,1000,249,array("R"=>0,"G"=>0,"B"=>0));
    $myPicture->drawLine(0,250,1000,250,array("R"=>70,"G"=>70,"B"=>70));

    /* Add a border to the picture */
    $myPicture->drawRectangle(0,0,999,299,array("R"=>204,"G"=>204,"B"=>204));

    /* Write the picture title */
    $myPicture->setFontProperties(array("FontName"=>$path_to_pChart."fonts/verdana.ttf","FontSize"=>8));
	$myPicture->drawText(500,14,$title,array("R"=>47,"G"=>47,"B"=>47,"Align"=>TEXT_ALIGN_MIDDLEMIDDLE));
    /* Define the chart area */
    $myPicture->setGraphArea(58,27,980,228);

    /* Draw a rectangle */
	$myPicture->drawFilledRectangle(58,27,980,228,array("R"=>180,"G"=>180,"B"=>180,"Dash"=>TRUE,"DashR"=>250,"DashG"=>250,"DashB"=>250,"BorderR"=>150,"BorderG"=>150,"BorderB"=>150));
        
	/* Turn on shadow computing */
    $myPicture->setShadow(TRUE,array("X"=>1,"Y"=>1,"R"=>0,"G"=>0,"B"=>0,"Alpha"=>20));

    /* Draw the scale */
    $myPicture->setFontProperties(array("R"=>47,"G"=>47,"B"=>47));
	if($type=="d") {
        $ScaleSettings = array("DrawArrows"=>TRUE,"ArrowSize"=>4,"Mode"=>SCALE_MODE_ADDALL_START0,"DrawSubTicks"=>FALSE,"GridR"=>0,"GridG"=>0,"GridB"=>0,"AxisR"=>0,"AxisG"=>0,"AxisB"=>0,"GridAlpha"=>30,"CycleBackground"=>TRUE);
	} else {
		$ScaleSettings = array("DrawArrows"=>TRUE,"ArrowSize"=>4,"DrawXLines"=>FALSE,"Mode"=>SCALE_MODE_ADDALL_START0,"DrawSubTicks"=>FALSE,"GridR"=>0,"GridG"=>0,"GridB"=>0,"AxisR"=>0,"AxisG"=>0,"AxisB"=>0,"GridAlpha"=>30,"CycleBackground"=>TRUE);
	} ;

	$myPicture->drawScale($ScaleSettings);

    /* Draw the spline chart */
    $myPicture->drawSplineChart();

    /* Write the chart boundaries */
    $BoundsSettings = array("MaxDisplayR"=>237,"MaxDisplayG"=>23,"MaxDisplayB"=>48,"MinDisplayR"=>23,"MinDisplayG"=>144,"MinDisplayB"=>237);
    $myPicture->writeBounds(BOUND_BOTH,$BoundsSettings);

    /* Write the chart legend */
    $myPicture->setFontProperties(array("R"=>47,"G"=>47,"B"=>47));
	$myPicture->drawLegend(450,258,array("Style"=>LEGEND_NOBORDER));

        
	/* Write the 1st data series statistics */
    $Settings = array("R"=>15,"G"=>44,"B"=>52,"Align"=>TEXT_ALIGN_BOTTOMLEFT);
    $myPicture->drawText(620,265,"Max : ".number_format(ceil($MyData->getMax($y1_title)), 0, '.', ' '),$Settings);
    $myPicture->drawText(700,265,"Min : ".number_format(ceil($MyData->getMin($y1_title)), 0, '.', ' '),$Settings);
    $myPicture->drawText(780,267,"Avg : ".number_format(ceil($MyData->getSerieAverage($y1_title)), 0, '.', ' '),$Settings);
	$myPicture->drawText(860,265,"Tot : ".number_format(ceil(array_sum($y1)), 0, '.', ' '),$Settings);


	if(!empty($compArray)) {
	    	/* Write the 2nd data series statistics */
	    	$Settings = array("R"=>184,"G"=>0,"B"=>40,"Align"=>TEXT_ALIGN_BOTTOMLEFT);
		$myPicture->drawText(620,278,"Max : ".number_format(ceil($MyData->getMax($y2_title)), 0, '.', ' '),$Settings);
     		$myPicture->drawText(700,278,"Min : ".number_format(ceil($MyData->getMin($y2_title)), 0, '.', ' '),$Settings);
        	$myPicture->drawText(780,280,"Avg : ".number_format(ceil($MyData->getSerieAverage($y2_title)), 0, '.', ' '),$Settings);
		$myPicture->drawText(860,278,"Tot : ".number_format(ceil(array_sum($y2)), 0, '.', ''),$Settings);

        	/* Write the 3rd data series statistics if set */
        	$Settings = array("R"=>240,"G"=>165,"B"=>40,"Align"=>TEXT_ALIGN_BOTTOMLEFT);
        	$myPicture->drawText(620,291,"Max : ".number_format(ceil($MyData->getMax($y3_title)), 0, '.', ' '),$Settings);
        	$myPicture->drawText(700,291,"Min : ".number_format(ceil($MyData->getMin($y3_title)), 0, '.', ' '),$Settings);
       	 	$myPicture->drawText(780,293,"Avg : ".number_format(ceil($MyData->getSerieAverage($y3_title)), 0, '.', ' '),$Settings);
		$myPicture->drawText(860,291,"Tot : ".number_format(ceil(array_sum($y3)), 0, '.', ' '),$Settings);

	} else {
	
        	/* Write the 3rd data series statistics if set */
        	$Settings = array("R"=>240,"G"=>165,"B"=>40,"Align"=>TEXT_ALIGN_BOTTOMLEFT);
        	$myPicture->drawText(620,278,"Max : ".number_format(ceil($MyData->getMax($y3_title)), 0, '.', ' '),$Settings);
        	$myPicture->drawText(700,278,"Min : ".number_format(ceil($MyData->getMin($y3_title)), 0, '.', ' '),$Settings);
        	$myPicture->drawText(780,280,"Avg : ".number_format(ceil($MyData->getSerieAverage($y3_title)), 0, '.', ' '),$Settings);
		$myPicture->drawText(860,278,"Tot : ".number_format(ceil(array_sum($y3)), 0, '.', ' '),$Settings);

	};

	/* Write the Service*/
	//$myPicture->setFontProperties(array("FontName"=>$path_to_pChart."fonts/verdana.ttf","FontSize"=>7));
        //$myPicture->drawText(830,297,"[ Blue-Mind ".date("d/m/Y H:i:s")." ] ",array("R"=>10,"G"=>10,"B"=>10));
        $myPicture->drawFromPNG(5,249,"/usr/share/bm-stats/scripts/PHP/do_graph/logo-bluemind.png");


	/* Render the picture (choose the best way) */
	$myPicture->render($img);
	
};

/* Fin des fonctions locales */





?>
